"  Copyright 2003  Alexander V. Diemand

    This file is part of MolTalk.

    MolTalk is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolTalk is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolTalk; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
"

[|
	" given a transformation, align two structural chains "

main
	| strx1 strx2 chain1 chain2 trafo |

	strxcode := nil.
        1 to: (ARGS count) - 1 do: [ :argc |
                arg := (ARGS objectAtIndex:(argc intValue)).
                "Transcript showLine:('argument: ',argc stringValue, ' ', arg)."
                (arg = '-strx1') ifTrue: [ targc := argc + 1. strx1 := StructureFactory newStructureFromPDBDirectory:(ARGS objectAtIndex:(targc)). ].
                (arg = '-strx2') ifTrue: [ targc := argc + 1. argument := ARGS objectAtIndex:targc. ((strx1 notNil) and: (argument = (strx1 pdbcode))) ifTrue: [ strx2 := strx1 ] ifFalse: [ strx2 := StructureFactory newStructureFromPDBDirectory:argument ]. ].
		((arg = '-chain1') and: (strx1 notNil)) ifTrue: [ targc := argc + 1. chain1 := strx1 getChain: ((ARGS objectAtIndex:targc) characterAtIndex:0). ].
		((arg = '-chain2') and: (strx2 notNil)) ifTrue: [ targc := argc + 1. chain2 := strx2 getChain: ((ARGS objectAtIndex:targc) characterAtIndex:0). ].
		(arg = '-trafo') ifTrue: [ targc := argc + 1. trafo := Matrix53 matrixFromString:(ARGS objectAtIndex:targc). ].
        ].


	(((chain1 notNil) and: (chain2 notNil)) and: (trafo notNil)) ifTrue: [ 
		Transcript showLine:'good.'.
		Transcript showLine:('strx1:',strx1 pdbcode,' chain1:',chain1 description).
		Transcript showLine:('strx2:',strx2 pdbcode,' chain2:',chain2 description).
		chain2 transformBy:trafo.
		pwstrxal := PairwiseStrxAlignment alignmentBetween:chain1 andChain:chain2.
		pwstrxal deriveStructuralAlignment.
		RMSD := pwstrxal calculateRMSD.
		naligned := pwstrxal countUngappedPairs.
		Transcript showLine:('rmsd=',RMSD stringValue,' naligned=',naligned stringValue).
		Transcript showLine:('* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *').
		alpositions := pwstrxal alignmentPositions .
		alLen := alpositions count.
		Transcript showLine:('>',chain1 fullPDBCode,' (',(((alpositions objectAtIndex:(alLen - 1))res1)key),'-',(((alpositions objectAtIndex:0)res1)key),')').
		(alLen - 1) to:0 step:(-1) do: [ :idx |
			alpos := alpositions objectAtIndex:idx.
			res1 := alpos res1.
			(res1 notNil) ifTrue: [ Transcript show:(res1 oneLetterCode) ]
				ifFalse: [ Transcript show:'-' ].
		].
		Transcript showLine:''.
		Transcript showLine:('>',chain2 fullPDBCode,' (',(((alpositions objectAtIndex:(alLen - 1))res2)key),'-',(((alpositions objectAtIndex:0)res2)key),')').
		(alLen - 1) to:0 step:(-1) do: [ :idx |
			alpos := alpositions objectAtIndex:idx.
			res2 := alpos res2.
			(res2 notNil) ifTrue: [ Transcript show:(res2 oneLetterCode) ]
				ifFalse: [ Transcript show:'-' ].
		].
		Transcript showLine:''.
		doVerify := Transcript readLine:'Do you want to verify the position? '.
		((doVerify = 'Y') or: (doVerify = 'y')) ifTrue: [ self verifyStrxal:alpositions ].
	] 
	ifFalse: [ self usage ].

	^self


!
usage
	Transcript showLine:'Usage: MolTalk alignStructures.st -strx1 <code> -strx2 <code> -chain1 <code> -chain2 <code> -trafo <Matrix53>'.
	Transcript showLine:''.
	^self


!
verifyStrxal:alpositions
	| alpos res1 res2 distance |
	Transcript showLine:('* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *').
	Transcript showLine:'verify aligned positions:'.
	(alLen - 1) to:0 step:(-1) do: [ :idx |
		alpos := alpositions objectAtIndex:idx.
		res1 := alpos res1.
		res2 := alpos res2.
		distance := alpos distance.
		(alpos isGapped) ifTrue: [
			(res1 notNil) ifTrue: [ Transcript show:(res1 oneLetterCode) ] 
				ifFalse: [ Transcript show:'-' ].
			Transcript show:' '.
			(res2 notNil) ifTrue: [ Transcript show:(res2 oneLetterCode) ] 
				ifFalse: [ Transcript show:'-' ].
			Transcript showLine:''.
		] ifFalse: [
			Transcript show:(res1 oneLetterCode).
			Transcript show:' '.
			Transcript show:(res2 oneLetterCode).
			Transcript show:' '.
			Transcript showLine:distance stringValue.
		].
	].
	^self


]
